<?xml version="1.0" encoding="utf-8"?>
<databaseChangeLog
    xmlns="http://www.liquibase.org/xml/ns/dbchangelog"
    xmlns:ext="http://www.liquibase.org/xml/ns/dbchangelog-ext"
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xsi:schemaLocation="http://www.liquibase.org/xml/ns/dbchangelog http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-3.5.xsd
                        http://www.liquibase.org/xml/ns/dbchangelog-ext http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-ext.xsd">

    <property name="now" value="now()" dbms="h2"/>

    <property name="now" value="GETDATE()" dbms="mssql"/>

    <property name="floatType" value="float4" dbms="postgresql, h2"/>
    <property name="floatType" value="float" dbms="mysql, oracle, mssql"/>
    
    <property name="UUID" value="binary(16)" dbms="mysql, mariadb"/>
    <property name="UUID" value="UUID" dbms="postgresql, h2, oracle, mssql"/>

    <property name="timestamp" value="datetime" dbms="mysql, mariadb, postgresql, h2, oracle, mssql"/>

    <property name="Integer" value="int" dbms="mysql, mariadb, postgresql, h2, oracle, mssql"/>
    <property name="String" value="varchar(100)" dbms="mysql, mariadb, postgresql, h2, oracle, mssql"/>

    <property name="BigDecimal" value="decimal(18,4)" dbms="mysql, mariadb, postgresql, h2, oracle, mssql"/>
    <!--
        Added the entity Billing.
    -->
    <changeSet id="20170101000000-1" author="jhipster">
        <createTable tableName="billing">
            <column name="idbilling" type="${UUID}">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            
            <column name="billingnumber" type="varchar(255)">
                <constraints nullable="true" />
            </column>

            <column name="dtcreate" type="${timestamp}">
                <constraints nullable="true" />
            </column>

            <column name="dtdue" type="${timestamp}">
                <constraints nullable="true" />
            </column>

            <column name="idbiltyp" type="${Integer}">
                <constraints nullable="true" />
            </column>

            <column name="idinternal" type="${String}">
                <constraints nullable="true" />
            </column>

            <column name="idbilto" type="${String}">
                <constraints nullable="true" />
            </column>

            <column name="idbilfro" type="${String}">
                <constraints nullable="true" />
            </column>

            <!-- jhipster-needle-liquibase-add-column - JHipster will add columns here, do not remove-->
        </createTable>

        <dropDefaultValue tableName="billing" columnName="dtcreate" columnDataType="datetime"/>
        <dropDefaultValue tableName="billing" columnName="dtdue" columnDataType="datetime"/>
        
        <createTable tableName="billing_status">
            
            <column name="idstatus" type="${UUID}"> 
                <constraints primaryKey="true" nullable="false"/>
            </column>

            <column name="idbilling" type="${UUID}">
                <constraints nullable="true" />
            </column>

            <column name="idstatustype" type="${Integer}">
                <constraints nullable="true" />
            </column>

            <column name="idreason" type="${Integer}">
                <constraints nullable="true" />
            </column>

            <column name="reason" type="${String}">
                <constraints nullable="true" />
            </column>            

            <column name="dtthru" type="${timestamp}">
                <constraints nullable="true" />
            </column>

            <column name="dtfrom" type="${timestamp}">
                <constraints nullable="true" />
            </column>

        </createTable>

        <addForeignKeyConstraint baseColumnNames="idbilling"
                                 baseTableName="billing_status"
                                 constraintName="fk_billing_from_status"
                                 referencedColumnNames="idbilling"
                                 referencedTableName="billing"/>        
        <createTable tableName="billing_role">
            
            <column name="idrole" type="${UUID}"> 
                <constraints primaryKey="true" nullable="false"/>
            </column>

            <column name="idbilling" type="${UUID}">
                <constraints nullable="true" />
            </column>

            <column name="idroletype" type="${Integer}">
                <constraints nullable="true" />
            </column>

            <column name="idparty" type="${UUID}">
                <constraints nullable="true" />
            </column>            

            <column name="dtthru" type="${timestamp}">
                <constraints nullable="true" />
            </column>

            <column name="dtfrom" type="${timestamp}">
                <constraints nullable="true" />
            </column>

        </createTable>

        <addForeignKeyConstraint baseColumnNames="idbilling"
                                 baseTableName="billing_role"
                                 constraintName="fk_billing_from_role"
                                 referencedColumnNames="idbilling"
                                 referencedTableName="billing"/>
    </changeSet>
    <!-- jhipster-needle-liquibase-add-changeset - JHipster will add changesets here, do not remove-->
</databaseChangeLog>
